# @smart-gate/query-params

This package allows you to keep your application's state in sync with the path Query, making it easier to share and manage states across different views and sessions with the help of History Browser API.

## Features

- Synchronize Data objects with URL query parameters.

- Stringy the given complex data, meanwhile getting back the original complex object.

- Framework agnostic

## Installation

You can install the package via npm:

```sh

npm install @smart-gate/query-params

```

or with yarn:

```sh

yarn add @smart-gate/query-params

```

## Usage

#### Example Component

Here's a simple example of a Vue component using @smart-gate/query-params:

```sh

<template>

   <div class="w-screen font-mono h-screen flex items-center mx-auto justify-center">

      {{ filter }}

     <div class="flex flex-col gap-5">

       <input v-model="filter.name" placeholder="Name" />
       <input v-model="filter.age" placeholder="Age" type="number" />
       <input v-model="filter.gender" placeholder="Gender" />

     </div>

 </div>

</template>



<script setup lang="ts">
import { ref, onMounted } from 'vue';
import { getQueryParams, setQueryParams } from '@smart-gate/query-params';

interface IFilter {
   name?: string;
   age?: number;
   gender?: string;
}

const filter = ref<IFormFields>({
	from_date: firstDayOfCurrentMon(),
	to_date: currentDate(),
	...getQueryParams()
});

watch(filter.value, newVal => {
	setQueryParams(newVal);
});

</script>

```
